=== debian/changelog ===
milkytracker (1.0.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

  * debian/control:
    - Change Gürkan's surname to Myczko (at his request).
    - Bump standards to 4.0.0 (no changes required).

 -- James Cowgill <jcowgill@debian.org>  Sun, 18 Jun 2017 22:29:52 +0100

milkytracker (1.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version.
    - Fixes FTBFS with GCC 7. (Closes: #853551)

  * debian/control:
    - Update new homepage.
    - Update various build dependencies for 1.0.0.
  * debian/compat:
    - Use debhelper compat 10.
  * debian/copyright:
    - Update copyright information for 1.0.0.
    - Exclude non-free music samples from source tarball.
  * debian/patches:
    - Drop all existing patches (obsolete in 1.0.0).
    - Add patch to prevent installing non-free music samples.

 -- James Cowgill <jcowgill@debian.org>  Thu, 13 Apr 2017 23:43:29 +0100
