=== debian/control ===
Source: milkytracker
Section: sound
Priority: optional
Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Gürkan Myczko <gurkan@phys.ethz.ch>,
 James Cowgill <jcowgill@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 10),
 dh-exec,
 libasound2-dev [linux-any],
 liblhasa-dev,
 libsdl2-dev,
 libjack-dev,
 librtmidi-dev [linux-any],
 libzzip-dev,
 zlib1g-dev
Homepage: http://milkytracker.titandemo.org/
Standards-Version: 4.0.0
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/milkytracker.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/milkytracker.git

Package: milkytracker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: freepats, opencubicplayer, xmp, schism, goattracker
Description: music creation tool inspired by Fast Tracker 2
 This is an editor for "tracked" music, i.e. audio samples of instruments
 pitch shifted according to the note data.
 .
 It can load the following module formats: 669, AMS, AMF, DBM, CBA, DIGI,
 DSM, FAR, GMC, GDM, IMF, IT, MOD, MDL, MTM, MXM, OKT, PLM, PSM, PTM, S3M,
 STM, ULT, UNI, and X.
 .
 Export is possible into the formats: XM, MOD, and WAV.
 .
 Supported sample and instrument formats: WAV, IFF/XI, PAT
