=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	rm $(CURDIR)/debian/milkytracker/usr/share/doc/milkytracker/Copying.txt
