## milkytracker 1.01.00+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,8 +19,11 @@
 #  along with MilkyTracker.  If not, see <http://www.gnu.org/licenses/>.
 #
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.5)
 project(MilkyTracker)
+
+# Adhere to GNU filesystem layout conventions
+include(GNUInstallDirs)
 
 # Force SDL if requested
 option(FORCESDL "Force SDL instead of native" OFF)
@@ -40,7 +43,7 @@
 
 # Version number in format X.YY.ZZ
 set(VER_X  1)
-set(VER_YY 00)
+set(VER_YY 01)
 set(VER_ZZ 00)
 set(VER_FULL "${VER_X}.${VER_YY}.${VER_ZZ}")
 
@@ -78,6 +81,17 @@
 include(CPack)
 
 if(APPLE)
+    # Warn if deployment target isn't set to Lion
+    if(NOT CMAKE_OSX_DEPLOYMENT_TARGET MATCHES "10.7")
+        message(WARNING
+            "Your deployment target is either unset or not set to \"10.7\", "
+            "which means that the binaries produced may not run on earlier "
+            "versions of macOS.\n"
+            "Please re-run CMake with '-DCMAKE_OSX_DEPLOYMENT_TARGET=10.7' "
+            "or change the variable in the CMake GUI to target Lion and newer."
+        )
+    endif()
+
     # Set variables for generating the Info.plist file
     set(MACOSX_BUNDLE_BUNDLE_VERSION "${VER_FULL}")
     set(MACOSX_BUNDLE_EXECUTABLE ${PROJECT_NAME})
@@ -103,14 +117,15 @@
     # Visual C++ Compiler options
     if(MSVC)
         # Warn if platform toolset may not be targetting Windows XP upwards
-        if(NOT ${CMAKE_VS_PLATFORM_TOOLSET} MATCHES "xp")
-            message("WARNING:")
-            message("Your currently-selected platform toolset may generate")
-            message("executables which are incompatible with Windows XP.")
-            message("Please set your toolset to be one of v110_xp, v120_xp or")
-            message("v140_xp for VS2012, VS2013, and VS2015 respectively.")
-            message("You can do so with the '-T' argument to CMake, or by")
-            message("entering it in the CMake GUI.")
+        if(NOT CMAKE_VS_PLATFORM_TOOLSET MATCHES "xp")
+            message(WARNING
+                "Your currently-selected platform toolset may generate "
+                "executables which are incompatible with Windows XP.\n"
+                "Please set your toolset to be one of v110_xp, v120_xp or "
+                "v140_xp for VS2012, VS2013, and VS2015 respectively.\n"
+                "You can do so with the '-T' argument to CMake, or by entering "
+                "it in the CMake GUI."
+            )
         endif()
 
         # Suppress secure string function warnings
@@ -156,10 +171,21 @@
     set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
 endif()
 
-# Under Windows we use Git Submodules to locate the decompression libraries
+# Under macOS and Windows we use Git Submodules to locate the decompression libs
 if(UNIX)
+    # zlib is provided by Linux and macOS
+    find_package(ZLIB)
+
+    # We can't use Brew for these due to OSX target version mismatch
+    # (we're targeting an older version of OSX to increase compatibility)
+    if(!APPLE)
+      find_package(LHASA)
+      find_package(ZZIPLIB)
+    endif()
+
     if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
         find_package(ALSA)
+        find_package(JACK)
 
         # Linux MIDI support requires ALSA and RtMidi
         if(ALSA_FOUND)
@@ -174,13 +200,6 @@
             message("MIDI support disabled (ALSA unavailable)")
         endif()
     endif()
-
-    if(NOT APPLE)
-        find_package(JACK)
-    endif()
-    find_package(LHASA)
-    find_package(ZLIB)
-    find_package(ZZIPLIB)
 endif()
 
 # Restore library suffixes
