=== debian/changelog ===
milkytracker (1.01.00+dfsg-1build1) bionic; urgency=medium

  * No-change rebuild against librtmidi4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 05 Nov 2017 06:45:11 +0000

milkytracker (1.01.00+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * debian/copyright:
    - Move apple-permissive license to the bottom.
    - Update for 1.01.
  * debian/patches:
    - Refresh.
    - Add upstream patch to fix lhasa, zziplib detection.
  * debian/rules:
    - Install documentation into lowercase doc dir.

 -- James Cowgill <jcowgill@debian.org>  Mon, 31 Jul 2017 11:26:28 +0100
