=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: milkytracker
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Team <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Gürkan Myczko <gurkan@phys.ethz.ch>,
  James Cowgill <jcowgill@debian.org>
